﻿using System;
using System.Activities;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Serialization;

using Microsoft.TeamFoundation.Build.Server;
using Microsoft.TeamFoundation.Common;
using Microsoft.TeamFoundation.Client;
using Microsoft.TeamFoundation.Framework.Server;

using artiso.TFSEventWorkflows.LoggingLib;

namespace artiso.TFSEventWorkflows.TFSActivitiesLib
{
  public sealed class GetTeamProjectCollection : CodeActivity
  {
    [RequiredArgument]
    public InArgument<TeamFoundationRequestContext> requestContext { get; set; }

    [RequiredArgument]
    public OutArgument<string> teamProjectCollectionUrl { get; set; }

    [RequiredArgument]
    public OutArgument<TfsTeamProjectCollection> teamProjectCollection { get; set; }

    protected override void Execute(CodeActivityContext context)
    {
      TeamFoundationRequestContext requestContext = context.GetValue(this.requestContext);
      var tfLocationService = requestContext.GetService<TeamFoundationLocationService>();
      var accessMapping = tfLocationService.GetServerAccessMapping(requestContext);
      Uri uriRequestContext = new Uri(tfLocationService.GetHostLocation(requestContext, accessMapping));
      UriBuilder uriBuilderRequestContext = new UriBuilder(uriRequestContext.Scheme, System.Environment.MachineName, uriRequestContext.Port, uriRequestContext.PathAndQuery);
      string teamProjectCollectionUrl = uriBuilderRequestContext.Uri.AbsoluteUri;
      var teamProjectCollection = new TfsTeamProjectCollection(new Uri(teamProjectCollectionUrl));

      context.SetValue(this.teamProjectCollectionUrl, teamProjectCollectionUrl);
      context.SetValue(this.teamProjectCollection, teamProjectCollection);
    }
  }
}
