﻿using System;
using System.Activities;
using System.Collections.Generic;
using System.Linq;
using System.Net.Mail;
using System.Text;
using artiso.TFSEventWorkflows.LoggingLib;

namespace artiso.TFSEventWorkflows.TFSActivitiesLib
{
    public sealed class SendMail : CodeActivity
    {
        [RequiredArgument]
        public InArgument<string> Host { get; set; }

        [RequiredArgument]
        public InArgument<int> Port { get; set; }

        [RequiredArgument]
        public InArgument<string> FromAdress { get; set; }

        [RequiredArgument]
        public InArgument<string> FromDisplayName { get; set; }

        [RequiredArgument]
        public InArgument<string> ToAdress { get; set; }

        [RequiredArgument]
        public InArgument<string> Subject { get; set; }

        [RequiredArgument]
        public InArgument<string> Body { get; set; }

        protected override void Execute(CodeActivityContext context)
        {
            string argHost = context.GetValue(this.Host);
            int argPort = context.GetValue(this.Port);
            string argFromAdress = context.GetValue(this.FromAdress);
            string argFromDisplayName = context.GetValue(this.FromDisplayName);
            string argToAdress = context.GetValue(this.ToAdress);
            string argSubject = context.GetValue(this.Subject);
            string argBody = context.GetValue(this.Body);

            // Command line argument must the the SMTP host.
            SmtpClient client = new SmtpClient(argHost, argPort);
            client.UseDefaultCredentials = true;

            // Specify the e-mail sender. 
            // Create a mailing address that includes a UTF8 character 
            // in the display name.
            MailAddress from = new MailAddress(argFromAdress, argFromDisplayName);
            // Set destinations for the e-mail message.
            MailAddress to = new MailAddress(argToAdress);
            // Specify the message content.
            MailMessage message = new MailMessage(from, to);
            message.Subject = argSubject;
            message.SubjectEncoding = System.Text.Encoding.UTF8;
            message.Body = argBody;
            message.BodyEncoding = System.Text.Encoding.UTF8;

            // send the mail
            client.Send(message);

        }
    }
}
